<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 04/29/2004 *
 * ===================                          Last change: 11/14/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-order.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Swapped out order system for PRO version         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Ausgelagertes Buchungssytem fuer PRO-Version     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version number
setThisExtensionVersion('0.5.3');

// Version history array (add more with , '0.0.1' and so on)
setExtensionVersionHistory(array('0.0.0', '0.1.0', '0.1.1', '0.1.2', '0.1.3', '0.1.4', '0.1.5', '0.1.6', '0.1.7', '0.1.8', '0.1.9', '0.2.0', '0.2.1', '0.2.2', '0.2.3', '0.2.4', '0.2.5', '0.2.6', '0.2.7', '0.2.8', '0.2.9', '0.3.0', '0.3.1', '0.3.2', '0.3.3', '0.3.4', '0.3.5', '0.3.6', '0.3.7', '0.3.8', '0.3.9', '0.4.0', '0.4.1', '0.4.2', '0.4.3', '0.4.4', '0.4.5', '0.4.6', '0.4.7', '0.4.8', '0.4.9', '0.5.0', '0.5.1', '0.5.2', '0.5.3'));

switch (getExtensionMode()) {
	case 'register': // Do stuff when installation is running
		// SQL commands to run
		addMemberMenuSql('order', 'order', 'Mailbuchung', 'N', 'Y', 1);
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addDropTableSql('url_blacklist');
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `what`='config_order' LIMIT 1");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `action`='order'");
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='Y', `locked`='N' WHERE `action`='order'");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_mod_reg` SET `hidden`='N', `locked`='N', `admin_only`='N', `mem_only`='Y' WHERE `module`='order' LIMIT 1");
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='N', `locked`='Y' WHERE `action`='order'");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_mod_reg` SET `hidden`='Y', `locked`='Y' WHERE `module`='order' LIMIT 1");
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.1.0': // SQL queries for v0.1
				addConfigAddSql('order_max_full', "ENUM('ORDER','MAX') NOT NULL DEFAULT 'MAX'");
				addAdminMenuSql('setup','config_order','Mailbuchungsseite','Einstellungen am Mailbuchungsformular.',7);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Maximale Mailbuchungen sind nun vom maximalen Empfang abh&auml;gig.");
				break;

			case '0.1.1': // SQL queries for v0.1.1
				// OLD QUERIES: addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `what`='config_order' LIMIT 1");
				// OLD QUERIES: addAdminMenuSql('setup','config_order','Mailbuchungsseite','Einstellungen am Mailbuchungsformular.',7);
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_user_data` ADD `mail_orders` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Maximale Mailbuchung vervollst&auml;ndigt (Admin-Bereich und im Buchungsformular selber).");
				break;

			case '0.1.3': // SQL queries for v0.1.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Maximale Mailbuchungen repariert (werden nun hochgez&auml;hlt und bei t&auml;glichem Reset auf 0 gesetzt).");
				break;

			case '0.1.4': // SQL queries for v0.1.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Dummy-Datenfeld wird wieder gel&ouml;scht, um Probleme zu vermeiden. Fehlende Spalte <em>mail_order</em> korregiert auf <em>mail_orders</em>.");
				break;

			case '0.1.5': // SQL queries for v0.1.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.1.6': // SQL queries for v0.1.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.1.7': // SQL queries for v0.1.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.1.8': // SQL queries for v0.1.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Problem mit Speicherung der Einstellungen beseitigt.");
				break;

			case '0.1.9': // SQL queries for v0.1.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Men&uuml;punkte im Gast-/Mitgliedsbereich k&ouml;nnen nicht mehr aufgerufen werden, wenn die Erweiterung deaktiviert ist.");
				break;

			case '0.2.0': // SQL queries for v0.2.0
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Seit <strong>Patch 340</strong> &uuml;berfl&uuml;ssige HTML-Tags entfernt.");
				break;

			case '0.2.1': // SQL queries for v0.2.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Templates <u>member_frameset-back.tpl</u> und <u>member_frameset-send.tpl</u> nach <u>member_order_back.tpl</u> und <u>member_order_send.tpl</u> umbenannt.");
				break;

			case '0.2.2': // SQL queries for v0.2.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Es wird nun &uuml;berpr&uuml;ft ob auch gen&uuml;gend Empf&auml;nger eingegeben worden sind und ob auch gen&uuml;gend empfangsbereit sind.");
				break;

			case '0.2.3': // SQL queries for v0.2.3
				addConfigAddSql('order_min', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 10');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Minimum an Empf&auml;nger pro Mailbuchung einstellbar. Standard: 10 Empf&auml;nger");
				break;

			case '0.2.4': // SQL queries for v0.2.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Anzahl mindestens einszustellende Empf&auml;nger wird nun auch angezeigt.");
				break;

			case '0.2.5': // SQL queries for v0.2.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Speicherung der Einstellungen klappt.");
				break;

			case '0.2.6': // SQL queries for v0.2.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler in Mailbuchung behoben: Es wurde beim Ermitteln der n&ouml;tigen {?POINTS?} die maximale Anzahl von Usern in der Kategorie gew&auml;hlt und
nicht die vom Mitglied eingegebene. Resultat: Das Script beschwerte sich, der User h&auml;tte nicht gen&uuml;gend {?POINTS?} auf dem Konto. Ein Rechenbeispiel:
<ol>
  <li>Das Mitglied w&auml;hlt eine Kategorie XYZ mit maximal 15 Empf&auml;ngern aus.</li>
  <li>Es stellt die Mailart <u>&quot;3 {?POINTS?} Kosten / Mail&quot;</u> ein.</li>
  <li>Es hat aber nur {?POINTS?} f&uuml;r 10 Empf&auml;nger und gibt 10 ein.</li>
  <li>Das Script hatte bis zu dieser Version 3 {?POINTS?} * <u>15</u> = 45 {?POINTS?} gerechnet, hat das Mitglied mehr oder gleich 45 {?POINTS?}, fiehl dieser Fehler nicht
  auf.</li>
  <li>Hatte es aber, wie hier im Beispiel 31 {?POINTS?}, konnte es nicht mehr buchen.</li>
  <li>Jetzt ist der Fehler endlich weg! Machen Sie dies bitte Ihren Mitgliedern bekannt.</li>
</ol>");
				break;

			case '0.2.7': // SQL queries for v0.2.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler mit <u>__MIN_VALUE</u> behoben.");
				break;

			case '0.2.8': // SQL queries for v0.2.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Konstantenproblem beseitigt.");
				break;

			case '0.2.9': // SQL queries for v0.2.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Problem mit nicht funktionierenden Mailbuchungen beseitigt.");
				break;

			case '0.3.0': // SQL queries for v0.3.0
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Basis-Modul <strong>order.php</strong> abgesichert, wenn Erweiterung nicht aktiviert ist.");
				break;

			case '0.3.1': // SQL queries for v0.3.1
				addConfigAddSql('order_select', "VARCHAR(255) NOT NULL DEFAULT 'userid'");
				addConfigAddSql('order_mode', "ENUM('ASC','DESC') NOT NULL DEFAULT 'DESC'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Beworbene URL wird nun getestet.");
				break;

			case '0.3.2': // SQL queries for v0.3.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Datumsformat festgelegt auf ausf&uuml;hrlich.");
				break;

			case '0.3.3': // SQL queries for v0.3.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Unter <strong>Einstellungen - Mailbuchungsseite</strong> war immer die Tabellenspalte <strong>Mitgliedsnummer</strong> ausgew&auml;hlt.");
				break;

			case '0.3.4': // SQL queries for v0.3.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Dateiamenskonflikt zwischen den Erweiterungen <strong>support</strong> und <strong>order</strong> behoben.");
				break;

			case '0.3.5': // SQL queries for v0.3.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Das Mitglied konnte geziehlt die Anzahl Mailbuchungen durch Abspeichern seines Profiles beeinflussen. Der Fehler war eine falsche Tabellenspalte. Dies war <strong>max_mails</strong>, die durch das Mitglieder ver&auml;nderbar ist und zur Festellung der Maximalen Mailbuchungen herangezogen wurde.");
				break;

			case '0.3.6': // SQL queries for v0.3.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Im Modul order (<strong>inc/modules/order.php</strong>) wurde fehlerhafterweise die Erweiterung <strong>beg</strong> getestet.");
				break;

			case '0.3.7': // SQL queries for v0.3.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("SQL-Anweisungen mit SQL_QUERY_ESC() abgesichert.");
				break;

			case '0.3.8': // SQL queries for v0.3.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Mailbuchungsseite korregiert.");
				break;

			case '0.3.9': // SQL queries for v0.3.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Erneuten Fehler in Mailbuchungsseite behoben.");
				break;

			case '0.4.0': // SQL queries for v0.4.0
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("{?POINTS?}-Abzug klappt wieder. Danke an Andreman!");
				break;

			case '0.4.1': // SQL queries for v0.4.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Abspeichern von Einstellungen repariert.");
				break;

			case '0.4.2': // SQL queries for v0.4.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Vorbereitung auf die neue Mediendaten v0.0.4.");
				break;

			case '0.4.3': // SQL queries for v0.4.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Neue Urlaubsschaltung mit integriert.");
				break;

			case '0.4.4': // SQL queries for v0.4.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Ein <strong>WHERE &#96;ext_active&#96;='Y'</strong> tauchte bei einigen Betreibern auf und ist mit dieser Version beseitigt.");
				break;

			case '0.4.5': // SQL queries for v0.4.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("De-/Aktivieren des mit dieser Erweiterung verkn&uuml;pften Modules eingebunden.");
				break;

			case '0.4.6': // SQL queries for v0.4.6
				addMemberMenuSql('order', NULL, 'Mailbuchungen', 'N', 'Y', 3);
				addMemberMenuSql('order', 'order2', 'Framekiller-Mails', 'N', 'Y', 2);
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `action`='order', `sort`=1, `title`='Klick-Mails' WHERE `what`='order' LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Mitgliedsmen&uuml; komplett umgebaut.");
				break;

			case '0.4.7': // SQL queries for v0.4.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehlerhinweis bei deaktivierter Erweiterung verbessert.");
				break;

			case '0.4.8': // SQL queries for v0.4.8
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET `title`='Mailbuchung' WHERE `what`='config_order' LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Men&uuml;punkt &quot;Mailbuchungsseite&quot; nach &quot;Mailbuchung&quot; umbenannt und weitere Einstellungen aus Sonstige Einstellungen verschoben.");
				break;

			case '0.4.9': // SQL queries for v0.4.9
				addConfigAddSql('repay_deleted_mails', "ENUM('REPAY','JACKPOT','SHRED') NOT NULL DEFAULT 'REPAY'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Bei L&ouml;schung von Mailbuchungen kann nun scripteweit entschieden werden (Einstellungen also), ob die verbliebenen {?POINTS?} wieder gutgeschrieben werden sollen oder in den Jackpot landen.");
				break;

			case '0.5.0': // SQL queries for v0.5.0
				addDropTableSql('url_blacklist');
				addCreateTableSql('url_blacklist', "(
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`url` VARCHAR(255) NOT NULL DEFAULT '',
`pool_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`timestamp` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
PRIMARY KEY (`id`),
INDEX (`pool_id`)
) ENGINE = {?_TABLE_TYPE?} CHARACTER SET utf8 COLLATE utf8_general_ci COMMENT = 'URL blacklist'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Tabelle f&uuml;r URL-Sperrliste angelegt.");
				break;

			case '0.5.2': // SQL queries for v0.5.2
				addConfigDropSql('test_text');
				addConfigDropSql('test_subj');
				addConfigAddSql('allow_url_in_text', "ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addConfigAddSql('allow_url_in_subject', "ENUM('Y','N') NOT NULL DEFAULT 'N'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Inkonsistenz in Konfigurationsnamen korregiert.");
				break;

			case '0.5.3': // SQL queries for v0.5.3
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_user_points` ADD `order_points` FLOAT(20,5) NOT NULL DEFAULT 0.00000');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_user_points` ADD `locked_order_points` FLOAT(20,5) NOT NULL DEFAULT 0.00000');

				// This update depends on ext-user
				addExtensionDependency('user');

				// Register filters for gathering points
				registerFilter(__FUNCTION__, __LINE__, 'get_total_points', 'ORDER_POINTS', true, isExtensionDryRun());
				registerFilter(__FUNCTION__, __LINE__, 'get_own_points', 'ORDER_POINTS', true, isExtensionDryRun());

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Weiteres {?POINTS?}-Guthabenkonto &quot;Werbeguthaben&quot; hinzugef&uuml;gt (verschoben von ext-user) und neue Filter zum Zur&uuml;ckliefern des Werbeguthabens hinzugef&uuml;gt.");
				break;
		} // END - switch
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes
		break;

	case 'init': // Do stuff when extension is initialized
		// Do daily reset only when installed and extension version is at least 0.1.1
		// @TODO This should be moved out to inc/daily/
		if ((isResetModeEnabled()) && (isInstalled()) && (isAdminRegistered()) && (isExtensionInstalledAndNewer('order', '0.1.1'))) {
			// Reset mail order values
			$result_ext = SQL_QUERY('UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `mail_orders`=0 WHERE `mail_orders` > 0', __FILE__, __LINE__);
		} // END - if
		break;

	case 'init': // Do stuff when extension is initialized
		break;

	default: // Unknown extension mode
		logDebugMessage(__FILE__, __LINE__, sprintf("Unknown extension mode %s in extension %s detected.", getExtensionMode(), getCurrentExtensionName()));
		break;
} // END - switch

// [EOF]
?>
