<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 01/09/2005 *
 * ===================                          Last change: 01/09/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_beg.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Setup beg link                                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Bettel-Link einstellen                           *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

if (isFormSent()) {
	// Replace german decimal comma with computer decimal dot
	convertCommaToDotInPostDataArray(array('beg_points', 'beg_points_max', 'beg_notify_bonus'));

	// Save settings
	adminSaveSettingsFromPostData();

	// Remember new settings
	setConfigEntry('beg_rallye'               , postRequestParameter('beg_rallye'));
	setConfigEntry('beg_rallye_enable_notify' , postRequestParameter('beg_rallye_enable_notify'));
	setConfigEntry('beg_rallye_disable_notify', postRequestParameter('beg_rallye_disable_notify'));
} else {
	// Prepare constants for the template
	$content['timeout']          = createConfigurationTimeSelections('beg_timeout'       , 'Dhm');
	$content['userid_timeout']   = createConfigurationTimeSelections('beg_userid_timeout', 'Dhm');
	$content['beg_ip_timeout']   = createConfigurationTimeSelections('beg_ip_timeout'    , 'Dhm');
	$content['wait_selection']   = createConfigurationTimeSelections('beg_notify_wait'   , 'ms' );

	// Init all Y/N selections
	foreach (array('rallye', 'active', 'mode', 'rallye_enable_notify', 'rallye_disable_notify', 'new_member_notify', 'include_own') as $entry) {
		$content[$entry . '_y'] = '';
		$content[$entry . '_n'] = '';
		$content[$entry . '_' . strtolower(getConfig('beg_' . $entry))] = ' checked="checked"';
	} // END - foreach

	// Init elements for faker-mode
	foreach (array('pay_mode_img','pay_mode_js','pay_mode_both','pay_mode_none') as $entry) {
		$content[$entry] = '';
	} // END - foreach

	// Set default faker-mode
	$content['pay_mode_' . strtolower(getBegPayMode())] = ' selected="selected"';

	// Init beg_mode elements
	foreach (array('DIRECT', 'REFERAL') as $entry) {
		$content['beg_mode_' . strtolower($entry)] = '';
	} // END - foreach

	// Set default mode
	$content['beg_mode_' . strtolower(getBegMode())] = ' checked="checked"';

	// Member selection box
	$content['beg_userid'] = addMemberSelectionBox(getBegUserid(), false, true, true, 'beg_userid');

	// Load form template
	loadTemplate('admin_config_beg', false, $content);
}

// [EOF]
?>
